package require Tcl 8.6
package require struct::set
package require inifile 0.3

package provide shops 1.0

namespace eval shops {

    proc getShopNameByTin {shops tin name} {
        if {[dict exists $shops $tin]} {
            return [dict get $shops $tin]
        } else {
            return $name
        }
    }

    proc setShopName {shopsVar tin name} {
        upvar $shopsVar shops

        dict set shops $tin $name
    }

    proc saveToFile {ini shops} {
        ::ini::delete $ini shops

        dict for {shop category} $shops {
            ::ini::set $ini shops $shop $category
        }
    }

    proc readFromFile {ini} {
        if {[::ini::exists $ini shops]} {
            return [::ini::get $ini shops]
        } else {
            return {}
        }
    }

    namespace export *

}

# vim: set ft=tcl:
