package require Tcl 8.6
package require struct::list 1.8

package provide uiutil 1.0

namespace eval uiutil {

    proc splitsToList {splits} {
        struct::list mapfor split $splits {
            list \
                [dict get $split text] \
                [dict get $split sum] \
                [dict get $split category] \
                [dict get $split pattern] \
                [dict get $split quantity]
        }
    }

    proc listToSplits {list} {
        struct::list mapfor item $list {
            lassign $item text sum category pattern quantity
            set manual [lindex {false true} [expr {$pattern eq "" && $category ne ""}]]
            dict create \
                text        $text       \
                sum         $sum        \
                manual      $manual     \
                category    $category   \
                pattern     $pattern    \
                quantity    $quantity
        }
    }

    proc firstUncategorizedInList {list index} {
        set i 0
        foreach item $list {
            if {$i < $index} {
                incr i
                continue
            }

            if {[lindex $item 2] eq ""} {
                return $i
            }

            incr i
        }
        return -1
    }

    proc firstUncategorizedInSplits {splits} {
        set i 0
        foreach split $splits {
            if {[dict get $split category] eq ""} {
                return $i
            }
            incr i
        }
        return -1
    }

    namespace export *
}

# vim: set ft=tcl:

